//=============================================================================
//  MuseScore
//  Linux Music Score Editor
//  $Id:$
//
//  Test plugin
//
//  Copyright (C)2008 Werner Schweer and others
//  2014 Modified by Hiroshi Tachibana
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License version 2.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//=============================================================================
//
// This is ECMAScript code (ECMA-262 aka "Java Script")
//
//---------------------------------------------------------
//    init
//    this function will be called on startup of mscore
//---------------------------------------------------------
function init(){}
//-------------------------------------------------------------------
//    run
//    this function will be called when activating the
//    plugin menu entry
//
//    global Variables:
//    pluginPath - contains the plugin path; file separator is "/"
//-------------------------------------------------------------------
function run(){
	var loader = new QUiLoader(null);
	var file   = new QFile(pluginPath + "/KotoNotation.ui"); // Qtファイルの指定
	file.open(QIODevice.OpenMode(QIODevice.ReadOnly, QIODevice.Text));
	form = loader.load(file, null);
	form.buttonBox.accepted.connect(accept);
	form.exec();
}
function accept(){
	var tuningBase = form.SpinBox_1.value;
	var inputLine = form.LineEdit.text;
	var numOfNote = []; // ある音程の音符の数を数えるための変数
	for( var ii=0 ; ii<128 ; ii++) numOfNote[ii]=0;
	var noteName = []; // ある音程の音符の数を数えるための変数
	var noteNameJ = []; // ある音程の音符の数を数えるための変数
	for( var ii=0 ; ii<128 ; ii++) {
		noteName[ii]="";
		noteNameJ[ii]="";
	}

	var Koto13 = form.radioButton_1.checked; // ボタンの状態を表す変数
	var Koto17 = form.radioButton_2.checked;
	var Koto20 = form.radioButton_3.checked;
	var Koto25H = form.radioButton_4.checked;
	var Koto25L = form.radioButton_5.checked;
	var MidiNo = form.radioButton_6.checked;
//	print("Koto Button="+Koto13+" "+Koto17+" "+Koto21+" "+Koto25);
	if(Koto13) var fingerings = ["A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q"]// 13絃箏：A-M:一〜巾、N:弱押し、O:強押し、P:二重押し,Q:四角形
	else if(Koto17) var fingerings = ["A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U"]// 17絃
	else if(Koto20) var fingerings = ["A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y"]// 21絃
	else if(Koto25H) var fingerings = ["A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z","a","b","c"]// 25絃
	else if(Koto25L) var fingerings = ["A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z","a","b","c"]// 低音25絃
	if(!MidiNo) var Lenf=fingerings.length-1;
	
	var fontSize = form.SpinBox_2.value;
//	print(" fontSize="+fontSize);
	var fontYOffset = form.SpinBox_3.value;
//	print(" YOffset="+fontYOffset);

	tuning=inputLine.split(",");
//	for(var i=0;i<tuning.length;i++) print("gen "+i+" = "+tuning[i]+"  "+(parseInt(tuning[i])+tuningBase));
//	print("tuning.length="+tuning.length);
	var select=true;// 選択があるorないの判定用の論理型変数の定義
	var currentCursor   = new Cursor(curScore);
	var selectionEnd = new Cursor(curScore);

	var poetText = curScore;
//	var poetTextJ = curScore;
//	poetText.poet="AAAAA";

	selectionEnd.goToSelectionEnd();
	var startStaff=currentCursor.staff;// 選択範囲の先頭小節
	var endStaff=selectionEnd.staff;//選択範囲の末端小節

	var currentCursor   = new Cursor(curScore);
	var i = 0;
	if(Koto13) var fontKoto = new QFont("Koto13T",fontSize); //  13絃、フォントとフォントサイズの設定
	else if(Koto17) var fontKoto = new QFont("Koto17T",fontSize); //  17絃、フォントとフォントサイズの設定
	else if(Koto20) var fontKoto = new QFont("Koto20T",fontSize); //  21絃、フォントとフォントサイズの設定
	else if(Koto25H) var fontKoto = new QFont("Koto25T",fontSize); //  25絃、フォントとフォントサイズの設定
	else if(Koto25L) var fontKoto = new QFont("Koto25LT",fontSize); //  25絃、フォントとフォントサイズの設定
	else if(MidiNo) var fontKoto = new QFont("Arial",fontSize); //  25絃、フォントとフォントサイズの設定
	var CrLf = '\r\n'; // 和音を縦に表示するための改行用文字列

	currentCursor.goToSelectionStart(); //選択範囲の先頭に移動
	if (currentCursor.eos()) { // 選択がない場合は、currentCursorは末端となる
		select=false;// 選択がないというフラグ
		startStaff = 0; // 範囲の先頭は、最初の小節
		endStaff = curScore.staves; // 範囲の末尾は、最後の小節
	}
//	for (i = curScore.staves; i > 0; i--){ //スコアの段、パートの数 のループ
//	for (var voice = 0; voice < 4; ++voice) {
//		currentCursor.voice = voice;
	currentCursor.staff = i-1;
	currentCursor.goToSelectionStart();
	if(!select)  currentCursor.rewind();//選択がないとき先頭に戻して先頭から.

	var pitch0;
	var firstNote=true;
	while (currentCursor.tick() < selectionEnd.tick()) {// 選択範囲内の音符を繰り返すLOOP
		if (currentCursor.isChord()){ // 現在位置が、音符である場合
			if(firstNote){
				pitch0 = currentCursor.chord().topNote().pitch; // 選択範囲の先頭の音符のMIDI Note Number
				firstNote=false;
			}
			var textKoto = new Text(curScore);
			textKoto.defaultFont= fontKoto;
			textKoto.xOffset = -3;
			textKoto.yOffset = fontYOffset;
			var chordLength = currentCursor.chord().notes; // 和音の音数
//			var len = chordLength-1; //和音の上下を逆にする場合
			var len=0;
			var oshide=0;
			var genNum;
		//while (len >= 0){ // 音符の読みを下から並べるループ　　 //和音の上下を逆とする場合
			while (len < chordLength){ // 音符の読みを下から並べるループ
				var pitch = currentCursor.chord().note(len).pitch; // 音符の音程

				for(var j=0 ; j<128 ; j++) if(pitch == j){
					numOfNote[j]=numOfNote[j]+1; // ある音程の音符の数を数える
					noteName[j]=currentCursor.chord().note(len).name; // 音符のある音程の音名を記録
				}

				for(var gen=0;gen<tuning.length;gen++){ // どの糸か、押し手があるかどうかを調べるための、一から巾へと糸の数だけ回るループ
					if(pitch == parseInt(tuning[gen])+tuningBase ){ // ある音程が、チューニングの音程と一致した場合
						genNum=gen; // 糸の番号とする
						oshide=0;
						break; // 弦が決まったので、一から巾のforループを抜ける
					}else if(pitch > parseInt(tuning[tuning.length-1])+tuningBase){ // 巾より高い場合
						genNum=tuning.length-1; // 糸は巾
						oshide=1; // 押し手が必要な音であるというフラグ
//						print("KIN no Oshide "+gen+" pitch="+pitch);
						break; // 弦が決まったので、一から巾のforループを抜ける
					}else{
						if(pitch > parseInt(tuning[gen])+tuningBase && pitch < parseInt(tuning[gen+1])+tuningBase ) { // ある音程が、チューニングの音程を下回った場合
//						}else if(pitch > tuning[gen]+tuningBase) { // ある音程が、チューニングの音程を下回った場合
							genNum=gen; // 一つ音程が下の糸の番号とする。
							oshide=1; // 押し手が必要な音であるというフラグ
//							print("Oshide "+gen+" pitch="+pitch);
							break; // 弦が決まったので、一から巾のforループを抜ける
						}
					}
				}
			//print("pitch="+pitch+"   tuning[genNum]+tuningBase="+(tuning[genNum]+tuningBase));
				if(MidiNo){
					textKoto.text+="   "+currentCursor.chord().note(len).name+CrLf+"   "+pitch+CrLf+"   "+(pitch-pitch0)+CrLf;// 英語音名、ノートナンバー、相対音程を与える

//noteNameJ[pitch]=fingerings[genNum];
//					if(pitch == parseInt(tuning[genNum])+tuningBase) noteNameJ[pitch]=fingerings[genNum]; // ある弦である場合
//					else if(pitch == parseInt(tuning[genNum])+tuningBase+1) noteNameJ[pitch]=fingerings[Lenf-3]+fingerings[genNum]; //弱押しの場合
//					else if(pitch == parseInt(tuning[genNum])+tuningBase+2) noteNameJ[pitch]=fingerings[Lenf-2]+fingerings[genNum]; //強押しの場合
//			  	else if(pitch == parseInt(tuning[genNum])+tuningBase+3) noteNameJ[pitch]=fingerings[Lenf-1]+fingerings[genNum]; //二重押しの場合

				}else{
					if(pitch == parseInt(tuning[genNum])+tuningBase) textKoto.text+="   "+fingerings[genNum]+CrLf; // ある弦である場合
					else if(pitch == parseInt(tuning[genNum])+tuningBase+1) textKoto.text+=fingerings[Lenf-3]+fingerings[genNum]+CrLf; //弱押しの場合
					else if(pitch == parseInt(tuning[genNum])+tuningBase+2) textKoto.text+=fingerings[Lenf-2]+fingerings[genNum]+CrLf; //強押しの場合
			  	else if(pitch == parseInt(tuning[genNum])+tuningBase+3) textKoto.text+=fingerings[Lenf-1]+fingerings[genNum]+CrLf; //二重押しの場合
					else if(pitch > parseInt(tuning[genNum])+tuningBase+3) textKoto.text+="   "+fingerings[Lenf]+CrLf; //三重押し以上の場合
					else if(pitch < parseInt(tuning[0])+tuningBase) textKoto.text+="   "+fingerings[Lenf]+CrLf; //一の弦より低い場合
				}
			//len = len-1; //和音の上下を逆とするの場合
				len = len+1;
			}
			currentCursor.putStaffText(textKoto); // 文字を出力
		}
		currentCursor.next();
	}
	var numOfNoteText="";
	if(MidiNo){
		for( var j=127 ; j>=0 ; j--) if(numOfNote[j] != 0) {
//			print(j+"  "+noteName[j]+" "+numOfNote[j]); // ある音程の音符の数を表示する。
			numOfNoteText+=poetText.poet=noteName[j]+String(parseInt(j/12)+0)+" : "+numOfNote[j]+CrLf;" : ";//+numOfNoteJ[j]+CrLf;
			// 箏の糸番号も表示するとよいが、フォントの設定が必要。箏の種類の情報も必要。MidiNoは使えない。
			// テキストの途中でフォントを変更する方法があるか？、２つの領域を使うか？
		}
	}
//	poetText.poet.color="Red";
	poetText.poet=numOfNoteText;
//	}
//	}
}

//---------------------------------------------------------
//    menu:  defines were the function will be placed
//           in the MuseScore menu structure
//---------------------------------------------------------
var mscorePlugin = {
	menu: 'Plugins.Koto Notation', // MuseScoreのプラグインメニュー内に表示される文字
	init: init,
	run:  run
};
mscorePlugin;
